#!/usr/bin/perl

# Set this to the event id in the /arimaa/events area; such as 2010wc
$EventID = "2010wc";

require "vars.pl";


$curdir = `/bin/pwd`;
chomp $curdir;
chdir "$GameroomDir";
require "crypt.pl";
require "cgi.pl";
require "html.pl";
require "datetime.pl";
require "data.pl";
require "cookie.pl";
require "processinput.pl";

# this is used to initilize the database connection
%s = DataGetSessionRec('1');

chdir "$curdir";


CgiPrintHeader();


use CGI ':cgi-lib';
&ReadParse();

$contButton = <<EOM;
<center>
<form target=_blank action="http://arimaa.com/arimaa/gameroom/" method=GET>
  <input type=submit value="Continue">
</form>
</center>
EOM

$loginButton = <<EOM;
<center>
<form target=_blank action="http://arimaa.com/arimaa/gameroom/" method=GET>
  <input type=submit value="Login">
</form>
</center>
EOM

$reloadButton = <<EOM;
  <form method=GET action="">
<center>
    <input type=submit value="Reload">
</center>
  </form>
EOM

# Omar added this on 2009.02.16
# Determine the prize amount for each round by reading the 'prize' file
open(FH,"<prize");
foreach $pline (<FH>){
  ($pfRound, $pfAmount) = ($pline =~ m/(\d+)\s+(\d+)/);
  if ($pfRound eq ''){ next; }
  $prize{$pfRound} = $pfAmount;
}
close FH;
    

chdir "$GameroomDir";

if ($in{auth}){
  if (Misc_crypt($in{u}, $in{auth}) < 1){
    HtmlErrorPage("Authentication Failed", "Incorrect authentication key");
    exit;
  }
}
else{
#goto skipLoginCheck; # if you uncomment this then also uncomment the
                      #   the $in{u} line below skipLoginCheck
  %c = CookieRead();
  if (! $c{sid}){
   if ($in{top}){ goto showTopPredictors; }
#######
# Uncomment these after testing
    HtmlErrorPage("Please Login.", "To enter predictions:<br>1. <a href='/arimaa/gameroom' target=_blank>Login</a> to the Arimaa gameroom.
<br>2 <a href=''>Reload</a> this page. <br><br><i>or</i><br><br><a href='?top=1'><!-- View Top Predictors -></a>");
    exit;
  }
  %p = DataGetSessionRec($c{sid});
  $in{u} = $p{username};
}

skipLoginCheck:
#############################
# Comment this out after testing; also comment the goto line above
#$in{u} = "omar";


$qu = Db_quote($in{u});
%p = DataGetPlayerRec("username=$qu");


if ($p{username} eq ""){
#######
# Uncomment these after testing
  &HtmlErrorPage("Please Login", "
<center>
1. Login to the Arimaa Gameroom.
$contButton
<br><br>
2. Reload this page.
$reloadButton
</center>
");
  exit;
}


showTopPredictors:

chdir "$curdir";

###############################
#  Make sure the user is registered to predict
open(FH, "<predictorList");
$regList = join('',<FH>);
close FH;

if ($regList !~ m/\b$in{u}\b/){
  if ($in{top} eq ""){
    HtmlErrorPage("Not Registered", "Please register first.");
    exit;
  }
}

###############################
# Store the predictions given by the user

if ($in{action} eq "predictions"){
  %pr = %in;
  delete $pr{u};
  delete $pr{action};

  while(($k, $v) = each(%pr)){
    if ($v eq 'needed'){
      HtmlErrorPage("Incomplete", "You must predict on all games. Provide both the winning player and number of moves.");
  exit;
    }
  }
  
  %spr = readPred($in{u});
  %tr = changed(\%spr, \%pr); # get time stamps for changed predictions
  %spr = (%spr, %tr); # override the saved predictions times
  %spr = (%spr, %pr); # override the saved predictions with the given
  savePred($in{u}, %spr);
  HtmlErrorPage("Predictions Entered", "Be sure to watch the games to see how you do.<br>You can change your predictions until the start of the game,<br>but in case more than one person predicts correctly the one<br> who entered their final perdiction for the game first will win.<p align=center>Check the gameroom to see which games will have live commentary.");
  exit;
}

sub changed{
  my($spr, $pr) = @_;
  my(%spr, %pr, $k, $v, $tk, %tr);

  %spr = %$spr;
  %pr = %$pr;
  while(($k, $v) = each(%pr)){
    if (($k =~ m/ m$/) || ($k =~ m/ w$/)){
      if ($spr{$k} ne $pr{$k}){
        $tk = $k;
        $tk =~ s/\w$//;
        $tk .= "t";
        $tr{$tk} = time;
      }
    }
  }
  return %tr;
}
  





###############################
# Read in all the user prediction files
@ul = `/bin/ls $UserPredDir/*`;
foreach $u (@ul){
  chomp $u;
  ($u) = ($u =~ m%\/([^\/]+)$%);
  if ($u ne ""){
    $UserRec{$u}{pred} = {readPred($u)};
#print "$UserRec{$u}{pred}{user}<br>\n";
  }
}


###############################
# Generate the game record hash
while (($u) = each(%UserRec)){
  while (($k, $v) = each(%{$UserRec{$u}{pred}})){
    if ($k =~ m/ w$/){
      $gk = $k; chop $gk; chop $gk;
      ($c) = ($v =~ m/(\d+)%/);
      $v =~ s/ .*$//;

      $GameRec{$gk}{$v}{w} += 1;
      $GameRec{$gk}{$v}{c} += $c;
    }
  }
# Need to do this in 2 passes; dont change to one pass; wont work
  while (($k, $v) = each(%{$UserRec{$u}{pred}})){
    if ($k =~ m/ m$/){
      $gk = $k; chop $gk; chop $gk;
      $w = $UserRec{$u}{pred}{"$gk w"};
      $w =~ s/ .*$//;
      $GameRec{$gk}{$w}{m} += $v;
    }
#    print "$k = $v <br>\n";
  }
}


###############################
# Generate the favored and underdog for each game
# make another copy of GameRec since we will be adding more to it 
#   as we loop through its elements
%myGameRec = %GameRec; 
while (($gk) = each(%myGameRec)){
  ($wp, $bp) = ($gk =~ m/^(\w+) +(\w+)/);
#print "'$wp' '$bp' <br>\n";
#print "'$GameRec{$gk}{$wp}{w}' '$GameRec{$gk}{$wp}{m}' <br>\n";
  ($wpv, $bpv) = ($GameRec{$gk}{$wp}{w}, $GameRec{$gk}{$bp}{w});
  if ($wpv eq ""){ $wpv = 0; }
  if ($bpv eq ""){ $bpv = 0; }

# Average predicted moves
  $wpm = 0; $bpm = 0;
  $wpc = 0; $bpc = 0;
  if ($wpv>0){
    $wpm = int($GameRec{$gk}{$wp}{m}/$GameRec{$gk}{$wp}{w} + 0.5);
    $wpc = int($GameRec{$gk}{$wp}{c}/$GameRec{$gk}{$wp}{w} + 0.5);
  }
  if ($bpv>0){
    $bpm = int($GameRec{$gk}{$bp}{m}/$GameRec{$gk}{$bp}{w} + 0.5);
    $bpc = int($GameRec{$gk}{$bp}{c}/$GameRec{$gk}{$bp}{w} + 0.5);
  }

#  $GameRec{$gk}{f} = "<nobr>$wpv for $wp in $wpm; $wpc% sure</nobr>";
#  $GameRec{$gk}{u} = "<nobr>$bpv for $bp in $bpm; $bpc% sure</nobr>";
  $GameRec{$gk}{f} = "<nobr>$wpv for $wp in $wpm</nobr>";
  $GameRec{$gk}{u} = "<nobr>$bpv for $bp in $bpm</nobr>";
  if ($bpv > $wpv){
    ($GameRec{$gk}{f}, $GameRec{$gk}{u}) = ($GameRec{$gk}{u}, $GameRec{$gk}{f});
  }
#print "$GameRec{$gk}{f} <br>\n";
}


# If the user has not entered their predictions for some games
#   also show those game and ask them to enter their predictions


###############################
# Display the predictions table

chdir "event";
use event::Tourn;
$e = ProcessInputChange($EventID, 'lower', 'alphaNum');
if ($e eq ''){
  HtmlErrorPage("Need Event", "The event id was not given.");
  exit;
}
if (! Tourn->exists($e)){
  HtmlErrorPage("Need Event", "The event [$e] was not found.");
  exit;
}
$ev = Tourn->load($e);
if (! $ev){
  HtmlErrorPage("Not Read", "Event [$e] could not be read.\n");
  exit;
}
chdir "$curdir";
%e = $ev->getEvent();
#$eventName = $ev->getEventFullName();
$Event = $ev->getEventFullName();

$now = time;

#@rounds = (1,5);

# round loop
$gameRows = "";

for($r=20;$r>=$StartRound;$r--){
#foreach $r (@rounds){


# 2010.02.06 Omar commented out the following and added new code below to get
#            the info for the games from the event state file
#  $fn = "";
############
## Change to use the r file after testing
##  if (-e "p${r}sched"){ $fn = "p${r}sched"; }
##  if (-e "p${r}results"){ $fn = "p${r}results"; }
#  if (-e "$RoundsDir/r${r}pairs"){ $fn = "r${r}pairs"; }
#  if (-e "$RoundsDir/r${r}sched"){ $fn = "r${r}sched"; }
#  if (-e "$RoundsDir/r${r}results"){ $fn = "r${r}results"; }
#  if ($fn eq ""){ next; }
#  $clickOnBoard = "";
#  $gameTimes = "";
#  open(FH, "<$RoundsDir/$fn");
#  foreach $l (<FH>){
##print "$l<br>\n";
#    ($win1, $win2, $w, $wr, $b, $br, $s, $ts, $why, $ply, $gid) = ($l =~ m/^(\w+) (\w+) \[(\w+) (\d+) vs (\w+) (\d+)\] (\d+) (\d+) (\w) (\d+) (\d+)/);
#    if ($w eq ""){
#      ($win1, $w, $wr, $b, $br, $s, $ts, $why, $ply, $gid) = ($l =~ m/^(\w+) \[(\w+) (\d+) vs (\w+) (\d+)\] (\d+) (\d+) (\w) (\d+) (\d+)/);
#    }
#    if ($w eq ""){
#      ($w, $wr, $b, $br, $s, $ts) = ($l =~ m/^\[(\w+) (\d+) vs (\w+) (\d+)\] (\d+) (\d+)/);
#    }
#    if ($w eq ""){
#      ($w, $wr, $b, $br) = ($l =~ m/^\[(\w+) (\d+) vs (\w+) (\d+)\]/);
##      $ts = $now + 30*86400;
#    }


# 2010.02.06 Omar added this to get the ratings of the players
  @p = $ev->getPlayersByRound($r);
  foreach $p (@p){
    $rating{$p->{u}} = $p->{r};
  }
# end of additions


# 2010.02.06 Omar added this to get the games for the round
  @g = $ev->getGamesByRound($r);
  foreach $g (@g){
    $ply = '';
    ($w, $b, $ts, $tc, $why, $ply, $gid) = ($g->{1}, $g->{2}, $g->{schts}, $g->{timecontrol}, $g->{why}, $g->{move}, $g->{gid});
    ($wr, $br) = ($rating{$w}, $rating{$b});
    $win1 = ''; $win2 = '';
    if ($g->{won} eq '1'){ $win1 = $w; }
    if ($g->{won} eq '2'){ $win1 = $b; }
    if ($g->{won} eq 'd'){ $win1 = $w; $win2 = $b; }
# end of additions

    if ($w eq ""){ next; }
    if ($w eq $b){ next; }

#print "$w, $wr, $b, $br, $s, $ts <br> \n";

    $gk = "$w $b $r";
#$xxd .= "<br>\n";
#$xxd .= "$gk - $win1 <br>\n";

# closest player
# Omar added this on 2008.02.28
# Find which user won the prediction for this game; the user who
#   predicts the right player and come closest to the number of
#   moves wins; in case of ties the player who predicted earlier wins
    $bestTime = ''; $bestDiff = ''; $bestPly = ''; $bestUser = '';
    undef @bestPred;
    if ($ply > 0){
$xxd .= "<br>\n";
$xxd .= "$w vs $b round=$r winner=$win1 $win2<br>\n";
      while (($u) = each(%UserRec)){
        $myPredPlayer = $UserRec{$u}{pred}{"$gk w"};
        $myPredMoves = $UserRec{$u}{pred}{"$gk m"};
        $myPredTime = $UserRec{$u}{pred}{"$gk t"};
        if ($myPredMoves eq ''){ next; }
        if (($win1 eq $u) || ($win2 eq $u)){ next; }
$xxd .= " $u said $myPredPlayer $myPredMoves $myPredTime <br>\n";
        if (($win1 eq $myPredPlayer) || ($win2 eq $myPredPlayer)){
#$xxd .= "$gk + $bestUser $bestPly<br>\n";
          $differ = abs($myPredMoves-$ply);
          push(@bestPred, sprintf("%04d%d", $differ, $myPredTime) . " $u $myPredMoves $myPredTime");
          if (($bestDiff eq '') || ($differ<=$bestDiff)){
            if (($differ == $bestDiff) && ($myPredTime > $bestTime)){
# then don't change the best player
            }
            else{
# player cannot predict number of moves on their own game
              if (($win1 eq $u) || ($win2 eq $u)){
# then don't change the best player
              }
              else{
                $bestDiff = abs($myPredMoves-$ply);
                $bestPly = $myPredMoves;
                $bestTime = $myPredTime;
                $bestUser = $u;
              }
            }
          }
        }
      }
$xxd .= "$gk - $bestUser $bestPly<br>\n";
    }
    @bestPred = sort(@bestPred);
    foreach (@bestPred){ $_ =~ s/^\d+ //; }
    $secondBest = "$bestPred[1]<br>$bestPred[2]";
 
# Omar added this on 2008.02.28
# Determine the amount the best user gets; depends on the round #
    $bestBonus = '';
    if ($r == 1){ $bestBonus = 5; }
    elsif ($r == 2){ $bestBonus = 5; }
    elsif ($r == 3){ $bestBonus = 10; }
    elsif ($r == 4){ $bestBonus = 15; }
    elsif ($r == 5){ $bestBonus = 20; }
    elsif ($r == 6){ $bestBonus = 10; } # 3rd place tie breaker
    elsif ($r == 7){ $bestBonus = 15; } # 3rd place tie breaker

# Omar added this on 2009.02.16
# Use the amounts in the 'prize' file to set the bestBonus
    $bestBonus = $prize{$r};
    $rightPlayerBonus = $prize{0};


###
# If we are to show only the top predictors, then add the score from this
#    game to each users total score.
    if ($in{top}){
      if ($ply>0){
# loop through the users
        while (($u) = each(%UserRec)){
          $myPredPlayer = $UserRec{$u}{pred}{"$gk w"};
          $myPredMoves = $UserRec{$u}{pred}{"$gk m"};
#################################
# Scores displayed on the Top Predictors page
#    Figure out the score for each game and total it for each player
#    If the player selected by the user wins or draws then the user gets
#    a maximum of a 100 points depending on how close the
#    number of moves they selected is to the actual. The smaller
#    of predicted and actual is divided by the greater so that only
#    if they predicted exactly right they would get 100 points.
#    If the game is a draw they get half the number of points.
# If you change the scoring method, also change it at other places in this file


          if ($ply > 0){
            $score = 0;
            $myPredPlayerName = $myPredPlayer;
            $myPredPlayerName =~ s/ .*$//;
            ($bonusw) = ($myPredPlayer =~ m/\+(\d+)/);
            ($bonusl) = ($myPredPlayer =~ m/\-(\d+)/);
            if ($bonusw eq ""){
              $bonusw = 19; $bonusl = 21;
            } 
# if he is also a player
            if (($w eq $u) || ($b eq $u)){
#              if ($win2 eq ""){ # not a draw
#                $myPly = $ply;
#                if ($myPly>70){ $myPly = 70; }
#                if ($win1 eq $u){ $score = (100-$myPly) + $bonusw; }
#                else{ $score = $myPly - $bonusl; }
##                if ($score < 0){ $score = 0; }
#              }
#              else{
#                $score = 25 + ($bonusw-$bonusl)/2;
#              }

# 2008.02.28 Omar added the following
# New way of scoring; when player is predictor
              if (($u eq $win1) || ($u eq $win2)){ # we won our own game
#$xxd .= "a '$u' '$win1' '$win2' <br>\n";
                if ($myPredPlayerName ne ""){
                  $score = $rightPlayerBonus;
                }
              }

            }
# if he is not one of the players and entered a prediction and the
#   predicted player won or drew.
            elsif ($myPredPlayerName ne "" && (($win1 eq $myPredPlayerName) || ($win2 eq $myPredPlayerName))){
#              $draw = ($win2 ne "")?2:1;
#              $score = ($myPredMoves>$ply)?$ply/$myPredMoves:$myPredMoves/$ply;
#              $score = $score*100/$draw;
#              if ($draw==2){
#                $score += ($bonusw-$bonusl)/2;
#              }
#              else{
#                $score += $bonusw;
#              }

# 2008.02.28 Omar added the following
# New way of scoring; when predictor is not a player
              if ($win1 eq $myPredPlayerName){
                $score = $rightPlayerBonus;
                if ($bestUser eq $u){
                  $score += $bestBonus;
                }
              }

            }
# else we did not make any prediction or predidted wrong; 
#            else{ $score = 0-$bonusl; }
#            $score = int($score + 0.5*($score>0?1:-1)); # round negative numbers properly     
            $UserRec{$u}{score} += $score;
          }     
        }
      }
######
# If showing only the top predictors we go to the next record here
      next;
    }


################
# Show the user his predictions and allow making predictions
#

# This is displayed in the 'Results' colum of the 'My Predictions' page
    $scheduled = ($ts>0) ? &getDayHrMin($ts - $p{timezone}) : '';
    if ($win1 ne ""){
      $scheduled = "<nobr>$win1 in $ply $why</nobr>";
    }


# Show the user what they predicted or allow them to make a prediction

    $myPredTime = $UserRec{$in{u}}{pred}{"$gk t"};

# setup the number of moves
    $myPredMoves = $UserRec{$in{u}}{pred}{"$gk m"};
    $movesOpt = "<option value='needed'>\n";
    for($moves=5; $moves<200; $moves++){
      $moveSelected = ($myPredMoves == $moves) ? "selected" : "";
      $movesOpt .= "<option $moveSelected>$moves\n";
    }

# setup the player and percentage
    $wopt = ""; $bopt = "";
#    foreach $percent (55,60,65,70,75,80,85,90,95,100){
    foreach $percent (100){
      $winper = abs(50**2 - (100-$percent)**2)/25;
      $loseper = abs(50**2 - $percent**2)/25;
#      $wopt .= "<option>$w $percent%  +$winper or -$loseper";
#      $bopt .= "<option>$b $percent%  +$winper or -$loseper";
      $wopt .= "<option>$w";
      $bopt .= "<option>$b";
    }
  
    $myPredPlayer = $UserRec{$in{u}}{pred}{"$gk w"};
    ($myPredPlayerPerc) = ($myPredPlayer =~ m/^(.*)%/);
    $myPred = <<EOM;
<nobr>
<select name="$w $b $r w">
  <option value="needed">select
$wopt
  <option value='needed'>------
$bopt
</select>
in
<select name="$w $b $r m">
  $movesOpt
</select>
</nobr>
EOM
    if ($myPredPlayer ne ""){
#      $myPred =~ s/<option>$myPredPlayerPerc/<option selected>$myPredPlayerPerc/;
      $myPred =~ s/<option>$myPredPlayer/<option selected>$myPredPlayer/;
    }
# If we are in the game then we have to vote for ourself
    if (($w eq $p{username}) || ($b eq $p{username})){
      if ($b eq $p{username}){ $wopt = $bopt; }
      $myPred = <<EOM;
<select name="$w $b $r w">
$wopt
</select>
<input type=hidden name="$w $b $r m" value=50>
EOM
#      $myPred =~ s/<option>$myPredPlayerPerc/<option selected>$myPredPlayerPerc/;
      $myPred =~ s/<option>$myPredPlayer/<option selected>$myPredPlayer/;
    }


# If the game time has started or if the game results are out then
#   we can't predict on this game.
    if ((($ts > 0) && ($now > $ts)) || ($ply>0) || ($win1 ne '') || ($PredictStartRound > $r)){
      $myPred = qq($myPredPlayer in $myPredMoves<br>$myPredTime);
      if ($UserRec{$in{u}}{pred}{"$gk w"} eq ""){ $myPred = " &nbsp; "; }
# if it is our own game; then we must predict on it; 55% by default
      if (($w eq $p{username}) || ($b eq $p{username})){
        $myPred = qq($myPredPlayer);
        if ($myPredPlayer eq ""){
#          $myPred = "$p{username} 55% +19 or -21";
#          $myPred = "$p{username}";
#          $myPredPlayer = $myPred;
        }
      }
# Dont need this any more
# If no one has made any predictions on this game then skip it
#      if (($GameRec{$gk}{f} eq "") && ($GameRec{$gk}{u} eq "")){
#        next;
#      }
    }
    else{
      $canPredict = 1;
    }


    $favored = "$GameRec{$gk}{f} <br> $GameRec{$gk}{u}";
    if ((($now < $ts) && ($ply<=0)) || ($ts eq "")){
      if ($PredictStartRound <= $r){
        $favored = "viewable after the game begins";
      }
    }

###################################
# Figure out the score for each game; displayed on My Predictions page.
#  If the player selected by the user wins or draws then the user gets
#    a maximum of a 100 points depending on how close the
#    number of moves they selected is to the actual. The smaller
#    of predicted and actual is divided by the greater so that only
#    if they predicted exactly right they would get 100 points.
#    If the game is a draw they get half the number of points.
# If you change the scoring method, also change it at other places in this file

    $score = " &nbsp; ";
# game results are available
#    if (($myPredMoves>=0) && ($ply > 0)){
    if ($ply > 0){
      $score = 0;
      $myPredPlayerName = $myPredPlayer;
      $myPredPlayerName =~ s/ .*$//;
      ($bonusw) = ($myPredPlayer =~ m/\+(\d+)/);
      ($bonusl) = ($myPredPlayer =~ m/\-(\d+)/);
      if ($bonusw eq ""){
        $bonusw = 19; $bonusl = 21;
      }
# if we are also a player
      if ((($w eq $p{username}) || ($b eq $p{username})) && ($ply > 0)){
#        if ($win2 eq ""){ # not a draw
#          $myPly = $ply;
#          if ($myPly>70){ $myPly = 70; }
#          if ($win1 eq $p{username}){ $score = (100-$myPly) + $bonusw; }
#          else{ $score = $myPly - $bonusl; }
##          if ($score < 0){ $score = 0; }
#        }
#        else{
#          $score = 25 + ($bonusw-$bonusl)/2;
#        }

# 2008.02.28 Omar added the following
# New way of scoring; when player is predictor
        if (($p{username} eq $win1) || ($p{username} eq $win2)){ # we won our own game
#$xxd .= "b '$u' '$win1' '$win2' <br>\n";
          if ($myPredPlayerName ne ""){ # but we have to enter our predictions
            $score = 1;
          }
        }

      }
# if we are not one of the players and entered a prediction
      elsif ($myPredPlayerName ne "" && (($win1 eq $myPredPlayerName) || ($win2 eq $myPredPlayerName))){
#        $draw = ($win2 ne "")?2:1;
#        $score = ($myPredMoves>$ply)?$ply/$myPredMoves:$myPredMoves/$ply;
#        $score = $score*100/$draw;
#        if ($draw==2){
#          $score += ($bonusw-$bonusl)/2;
#        }
#        else{
#          $score += $bonusw;
#        }

# 2008.02.28 Omar added the following
# New way of scoring; when predictor is not a player
        if ($win1 eq $myPredPlayerName){
#          $score = 1;
          $score = $prize{0};
          if ($bestUser eq $p{username}){
            $score += $bestBonus;
          }
        }
        
      }
# else we did not make any prediction; we lose points as if we made 
#    a 55% prediction on the losing player
#      else{ $score = 0-$bonusl; }
#      $score = int($score + 0.5*($score>0?1:-1)); # round negative numbers properly
      $totScore += $score;
    }



    $sideG = 'G'; $sideS = 'S';
    if ($win1 ne ""){
      if (($ply>0) && ($gid>0)){
        $sideG = qq(<a href='/arimaa/gameroom/comments.cgi?gid=$gid&s=w' target=_blank>G</a>);
        $sideS = qq(<a href='/arimaa/gameroom/comments.cgi?gid=$gid&s=s' target=_blank>S</a>);
      }
    }
 

#print "$w, $wr, $b, $br, $s, $ts <br> \n";

# Order the game so that games which are yet to be played are presented before
#   games that have already been played. Order the games yet to be played so
#   that games which are closer to the current time are at the top. Order the
#   games that have already been played been played such that games which were
#   more recently played are at the top.
    $ordts = $ts;
    if ($gid eq ""){
      $ordts += 100*86400 - 2*($ts - $now);
    }
    if ($ts eq ''){
      $ordts = $r;
    }
    $gameRow = <<EOM;
$ordts

<tr>

<td align=left>
<nobr>$sideG <a href="javascript:playerPage('$w')">$w</a><font size=-1> &nbsp; $wr</font></nobr>
<br>
<nobr>$sideS <a href="javascript:playerPage('$b')">$b</a><font size=-1> &nbsp; $br</font></nobr>
</td>

<td>$favored</td>

<td>$myPred</td>

<td align=center><nobr>$scheduled</nobr></td>

<td align=right>$score</td>

<td align=right><font color=red>$bestUser $bestPly $bestTime</font><br>$secondBest</td>

</tr>
EOM
    push(@gameRows, $gameRow);

$newRows .= <<EOM;
$w, $wr, $b, $br, $s, $ts <br> 
EOM

  }

}

@gameRows = reverse(sort(@gameRows));
foreach(@gameRows){
  $_ =~ s/^\d+//s;
}
$gameRows = join('', @gameRows);




####
# If we are to show only the top scoring players then do it here.
if ($in{top}){

# 2010.02.11 Omar added these lines so that the list of top predictors is not shown.
#            That way people can't try to figure out who voted for which player.
    HtmlErrorPage("No Finished Games", "Check again after some games have been completed.");
    exit;

  while (($u) = each(%UserRec)){
    if ($UserRec{$u}{score} ne ""){
      push(@topSc, sprintf("%05d %s", $UserRec{$u}{score}, $u));
    }
  }
  if ($#topSc <0){
    HtmlErrorPage("No Finished Games", "Check again after some games have been completed.");
    exit;
  }
  @topSc = sort {$b <=> $a} @topSc;
#  @topSc = reverse(@topSc);
  foreach $u (@topSc){
    ($s, $u) = split(/ /, $u);
    $s = sprintf("%d", $s);
    $topRows .= <<EOM;
<tr>
  <td><a href="javascript:playerPage('$u')">$u</a></td>
  <td align=right>$s</td>
</tr>
EOM
  }
  print <<EOM;
<html>
  <head><title>$Event</title></head>
  <body bgcolor=#d8d8f8>
    <center>
<p><font size=+2><b>$Event<br>Top Predictors</b></font>

<p><a href="predictions.cgi"><b>My Predictions</b></a>
<p>
    <table border=1>
<tr>
<td align=center bgcolor=#aaaaff><b>Username</b></td>
<td align=center bgcolor=#aaaaff><b>Score</b><font size=1><br>
<!-- <a href="predictHow.html" target=_blank>How?</a>
-->
</td>
</tr>
$topRows
    <table>
    </center>
 <script language="JavaScript1.2">
<!--
function playerPage(u){
    open('/arimaa/gameroom/playerpage.cgi?u='+u,'','toolbar=no,width=650,height=550,scrollbars=yes,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
    void('');
}

function how(){
  alert(" How is the score determined? \\n\\n If the player you predicted wins or draws then, \\n the lesser of your predicted number of moves or the actual number of moves \\n is divided by the greater of these two numbers and multiplied by 100. \\n In case of a draw the score is divided by 2. \\n The result is rounded to the nearest whole number. \\n\\n The score for all games in which you predicted is summed to get your final score. ");
  void('');
}

// -->
    </script>
  </body>
</html>
EOM
  exit;
}

$gameRows = <<EOM;
<tr>
<td align=center bgcolor=#aaaaff><b>Games</b></td>
<td align=center bgcolor=#aaaaff><b>Predictions</b></td>
<td align=center bgcolor=#aaaaff><b>My Predictions</b>
  <br>
  <input type=submit value="Submit Predictions">
  <input type=hidden name=action value=predictions>
</td>
<td align=center bgcolor=#aaaaff><b>Results</b></td>
<td align=center bgcolor=#aaaaff><b>Score</b><font size=1>
<!--
<br><a href="predictHow.html" target=_blank>How?</a>
-->
</td>
<td align=center bgcolor=#aaaaff><b>Winner</b></td>
</tr>
$gameRows
EOM

$gamePlayers = "<td>Game</td> $gamePlayers";
$gameResult = "<td>Result</td> $gameResult";
$myPred = <<EOM;
<td>My Predictions
<br>
<input type=submit value="Submit Prediction">
<input type=hidden name=action value=predictions>
$myPred
</td>
EOM


if ($canPredict ne ""){
  $selectWhichPlayer = <<EOM;
<!--
<p><font xsize=+1>
<a href="predictHow.html">How to make your predictions</a>.
</font>
-->
EOM
}

if ($totScore){
  $yourTotalScore = <<EOM;
<p><font xsize=+1>
Your current total score is <b>$totScore</b>.
</font>
EOM
}

if ($p{username} ne 'omar'){
  $xxd = '';
}

print <<EOM;
<html>
  <head><title>$Event</title></head>
  <body bgcolor=#d8d8f8>
    <center>
<!--
$xxd
-->
<p><font size=+2><b>$Event<br>My Predictions</b></font>

<p><font xsize=+2><b><a href="?top=1"><!-- Top Predictors --></a></b></font>

$yourTotalScore
$selectWhichPlayer

<p>
    <form method=POST>
    <table border=1>
$gameRows
    </table>
    </form>
    </center>
 <script language="JavaScript1.2">
<!--
function playerPage(u){
    open('/arimaa/gameroom/playerpage.cgi?u='+u,'','toolbar=no,width=650,height=550,scrollbars=yes,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
    void('');
}

function openGame(id, role, side){
  if (id != ''){
    open('/arimaa/games/showGame.cgi?gid='+id+'&s='+side,'','toolbar=no,width=350,height=250,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
  }
  else{
    alert("To watch the game login to the Arimaa gameroom and click on 'Current Games'");
  }
  void('');
}

function how(){
  alert(" How is the score determined? \\n\\n If the player you predicted wins or draws then, \\n the lesser of your predicted number of moves or the actual number of moves \\n is divided by the greater of these two numbers and multiplied by 100. \\n In case of a draw the score is divided by 2. \\n The result is rounded to the nearest whole number. \\n\\n The score for all games in which you predicted is summed to get your final score. ");
  void('');
}

// -->
    </script>
  </body>
</html>

EOM

exit;

sub Str2AssocList{
  local ($inp, $sep, $seq) = @_;
  local (%al, @a);
  local ($key, $val);

  if ($sep eq ""){
    $sep  = ";";
  }
  if ($seq  eq ""){
    $seq = "=";
  }
  @a = split($sep, $inp);
  foreach(@a){
    ($key, $val) = (/([^$seq]+)$seq(.*)/);
    if ($key){
      $al{$key} = $val;
    }
  }
  return %al;
}

sub AssocList2Str{
  local ($al, $sep, $seq) = @_;
  local (%al, @a, $str);

  %al = %$al;

  if ($sep eq ""){
    $sep  = ";";
  }
  if ($seq  eq ""){
    $seq = "=";
  }
  while(($key, $val) = each(%al)){
    push(@a, "$key$seq$val");
  }
  $str = join("$sep", @a);
  return $str;
}

sub readPred{
  local($u) = @_;
  local($s, *FH, %p);

  open(FH, "<$UserPredDir/$u");
  $s = join('', <FH>);
  close FH;
  %p = Str2AssocList($s, "\n");
  return %p;
}

sub savePred{
  local($u, %p) = @_;
  local($s, *FH);

  $p{user} = $u;
  $s = AssocList2Str(\%p, "\n");
  open(FH, ">$UserPredDir/$u");
  print FH $s;
  close FH;
}


